package com.lwby.aas.controller;

import com.alibaba.fastjson2.JSON;
import com.alibaba.fastjson2.JSONObject;
import com.lwby.aas.DeviceType;
import com.lwby.aas.enums.CallEnum;
import com.lwby.aas.factory.AttributeHandleFactory;
import com.lwby.aas.handle.AttributionHandle;
import com.lwby.aas.handle.BaseHelper;
import com.lwby.aas.handle.Flow;
import com.lwby.aas.util.BaseCallHelper;
import com.lwby.aas.vo.*;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.annotation.Resource;
import java.util.Objects;

/**
 * @author songxinyu
 * @version AttributeController.java, v 0.1 2024年02月23日 18:57 songxinyu Exp $
 */
@Controller
@RequestMapping(value = "/attr")
@Slf4j
@ResponseBody
public class AttributeController extends BaseHelper {

    @Resource
    BaseCallHelper baseCallHelper;

    @Resource
    AttributeHandleFactory attributeHandleFactory;

    @RequestMapping("/testUpload")
    public void testUpload() {
        String msg = "{\"bookStoreEvent\":1,\"clientInfo\":{\"channel\":210633175,\"clientIp\":\"119.2.220.77\","
                + "\"dID\":\"5af3a4af1984ccfa\",\"ddid\":\"DuZJq0+2z8dswVG3NtNQ96J/HQpiln+MXLew/8UZ/TllZSj5PedZVPzn71LxK9g"
                + "+WdYQboRXHBGJIs6xKyQyehFg\",\"firm\":\"OPPO\",\"fixVersion\":2,\"mainVersion\":2,"
                + "\"oaid\":\"086C4916ADF84ED8AF7B36CC9AC2E6C40f99db49e719aea064697461d0f7756c\",\"os\":\"0\",\"phoneModel\":\"PFVM10\","
                + "\"pkv\":1,\"platformGroupId\":6,\"platformId\":6,\"pm\":\"PFVM10\",\"screenSize\":\"720*1504\","
                + "\"sessionid\":\"wnL6tS5SxV-wnLtNuOOK-942FVeOLLKbj\",\"signVersion\":2,\"subVersion\":30,\"systemVersion\":\"12\","
                + "\"ua\":\"Mozilla/5.0 (Linux; Android 12; PFVM10 Build/SP1A.210812.016; wv) AppleWebKit/537.36 (KHTML, like Gecko) "
                + "Version/4.0 Chrome/97.0.4692.98 Mobile Safari/537.36\",\"user\":{\"career\":\"\",\"channel\":210633175,"
                + "\"deviceId\":\"5af3a4af1984ccfa\",\"experience\":1,\"gender\":\"M\",\"headImage\":\"http://cdn.ibreader"
                + ".com/group1/M00/56/07/rBH0olunjn2AeTz8AAAQDrNZNzM090.png\",\"id\":129915974,\"isKaiqiUser\":false,\"isMajia\":false,"
                + "\"isPrivate\":false,\"lastLogin\":1693280011000,\"level\":0,\"mainversion\":2,\"nickname\":\"书友254834\","
                + "\"platformId\":6,\"registrationDate\":1693280011000,\"subversion\":30,\"userStatus\":0,"
                + "\"username\":\"bdNGcUn2jmCeRD\"},\"version\":\"6.2.30.02.210633175\","
                + "\"visitor\":\"wnL6tS5SxV-wnLtNuOOK-942FVeOLLKbj\",\"xClient\":\"dID=5af3a4af1984ccfa;os=0;firm=OPPO;webVersion=new;"
                + "version=6.2.30.02.210633175;username=wnL6tS5SxV-wnLtNuOOK-942FVeOLLKbj;"
                + "ddid=DuZJq0+2z8dswVG3NtNQ96J/HQpiln+MXLew/8UZ/TllZSj5PedZVPzn71LxK9g+WdYQboRXHBGJIs6xKyQyehFg;sv=12;pm=PFVM10;"
                + "ss=720*1504;signVersion=2;androidosv=31;oaid=086C4916ADF84ED8AF7B36CC9AC2E6C40f99db49e719aea064697461d0f7756c;pkv=1;"
                + "\"},\"createTime\":1708877129228,\"extraData\":{},\"id\":\"5302e518-27b6-44e0-8077-499e0d31ad89\"}";

        BookStoreEvent event = JSONObject.parseObject(msg, BookStoreEvent.class);
        ClientInfo clientInfo = event.getClientInfo();

        //获取用户注册时间
        UserProfile userProfile = clientInfo.getUser();
        if (userProfile == null || userProfile.getRegistrationDate() == null) {
            log.error("ClientInfo.userProfile 对像为[{}],BookStoreEvent报文[{}]、对像[{}]",userProfile, msg, event);
            return;
        }

        //ANDROID deviceId
        String deviceId = clientInfo.getDID();
        //平台ID
        Integer platformId = clientInfo.getPlatformId();
        //设备ID类型
        DeviceType deviceType = null;
        //设备ID
        String deviceIdKey = null;
        //VO对像
        DeliveryDeviceInfo deliveryDeviceInfo = null;

        //匹配设备ID
        for(DeviceType type:DeviceType.values()){
            deviceIdKey = type.getDeviceId(clientInfo);
            if(null != deviceIdKey && null != (deliveryDeviceInfo = getForRedis(assembleKey(deviceIdKey,platformId,type)))){
                deviceType = type;
                clientInfo.setOaid(deliveryDeviceInfo.getOaid());   //回补OAID
                break;
            }
        }

        if(DeviceType.IP == deviceType){
            //TODO；只发BI 不上报逻辑
            baseCallHelper.summaryByUserChannel(clientInfo,CallEnum.IP_CALLBACK.getValue(),deliveryDeviceInfo);
            return;
        }

        Action action = new Action(clientInfo,deliveryDeviceInfo);
        for(AttributionHandle handle:attributeHandleFactory.getHandleList()){
            if(handle.handle(action) != Flow.NEXT){
                break;
            }
        }
    }
}
