package com.lwby.aas.enums;

/**
 * @author songxinyu
 * @version CallEnum.java, v 0.1 2024年02月23日 10:27 songxinyu Exp $
 */
public enum CallEnum {

    /**
     * 激活回传
     */
    ACTIVE_CALLBACK {
        @Override
        public Integer getValue() {
            return 2;
        }

        @Override
        public String getDescription() {
            return "激活回传";
        }
    },

    /**
     * 商店
     */
    STORE_CALLBACK {
        @Override
        public Integer getValue() {
            return 3;
        }

        @Override
        public String getDescription() {
            return "商店";
        }
    },

    /**
     * 正常扣量
     */
    NORMAL_DEDUCTION_CALLBACK {
        @Override
        public Integer getValue() {
            return 4;
        }

        @Override
        public String getDescription() {
            return "正常扣量";
        }
    },
    /**
     * 老用户扣量（不是当天，活跃天数内）
     */
    OLDUSER_DEDUCTION_CALLBACK {
        @Override
        public Integer getValue() {
            return 7;
        }

        @Override
        public String getDescription() {
            return "老用户扣量";
        }
    },
    /**
     * ip获取点击对象
     */
    IP_CALLBACK {
        @Override
        public Integer getValue() {
            return 9;
        }

        @Override
        public String getDescription() {
            return "ip";
        }
    },

    ;

    /**
     * 获取对应的枚举的值
     *
     * @return 对应的枚举的值
     */
    public abstract Integer getValue();

    /**
     * 获取对应的枚举的描述
     *
     * @return 对应的枚举的描述
     */
    public abstract String getDescription();

    /**
     * 根据对应的枚举的值获取回传类型枚举, 未找到则返回null
     *
     * @param value 对应的枚举的值
     * @return 对应的枚举, 未找到则返回null
     */
    public static CallEnum getCallEnum(Integer value) {
        for (CallEnum callEnum : CallEnum.values()) {
            if (callEnum.getValue().equals(value)) {
                return callEnum;
            }
        }
        return null;
    }
}
