package com.lwby.aas.enums;

/**
 * 媒体枚举
 * @author zhangxz
 * @version MediaEnum.java, v 0.1 2021年01月15日 14:33 zhangxz Exp $
 */
public enum MediaEnum {
    /**
     * 爱奇艺
     */
    QI_YI {
        @Override
        public String getMediaName() {
            return "qiYi";
        }
        @Override
        public String getDesc() {
            return "爱奇艺";
        }
    },
    /**
     * 今日头条
     */
    TOU_TIAO {
        @Override
        public String getMediaName() {
            return "jrtt";
        }
        @Override
        public String getDesc() {
            return "今日头条";
        }
    },
    /**
     * 今日头条洋葱
     */
    TOU_TIAO_ONION {
        @Override
        public String getMediaName() {
            return "jrtt_onion";
        }
        @Override
        public String getDesc() {
            return "今日头条洋葱";
        }
    },
    /**
     * 广点通
     */
    GDT {
        @Override
        public String getMediaName() {
            return "gdt";
        }
        @Override
        public String getDesc() {
            return "广点通";
        }
    },
    /**
     * 快手
     */
    KUAI_SHOW {
        @Override
        public String getMediaName() {
            return "kuaishou";
        }
        @Override
        public String getDesc() {
            return "快手";
        }
    },
    /**
     * 百度
     */
    BAI_DU {
        @Override
        public String getMediaName() {
            return "baidu";
        }
        @Override
        public String getDesc() {
            return "百度";
        }
    },
    /**
     * 百度搜索
     */
    BAI_DU_SOU_SUO {
        @Override
        public String getMediaName() {
            return "baidusousuo";
        }
        @Override
        public String getDesc() {
            return "百度搜索";
        }
    },
    /**
     * 微信
     */
    WECHAT {
        @Override
        public String getMediaName() {
            return "wechat";
        }
        @Override
        public String getDesc() {
            return "微信";
        }
    },
    /**
     * UC浏览器
     */
    UC {
        @Override
        public String getMediaName() {
            return "uc";
        }
        @Override
        public String getDesc() {
            return "UC浏览器";
        }
    },
    /**
     * UC搜索
     */
    UC_SOU_SUO {
        @Override
        public String getMediaName() {
            return "ucsousuo";
        }
        @Override
        public String getDesc() {
            return "UC搜索";
        }
    },
    /**
     * 趣头条
     */
    QU_TOU_TIAO {
        @Override
        public String getMediaName() {
            return "qutoutiao";
        }
        @Override
        public String getDesc() {
            return "趣头条";
        }
    },
    /**
     * 快手磁力聚星
     */
    KUAI_SHOU_KOL {
        @Override
        public String getMediaName() {
            return "kuaishoukol";
        }
        @Override
        public String getDesc() {
            return "磁力聚星";
        }
    },
    /**
     * 迅雷红桃h5
     */
    HONGTAO_H5 {
        @Override
        public String getMediaName() {
            return "hongtaoh5";
        }
        @Override
        public String getDesc() {
            return "迅雷红桃h5";
        }
    },
    /**
     * 小米
     */
    XIAOMI {
        @Override
        public String getMediaName() {
            return "xiaomi";
        }
        @Override
        public String getDesc() {
            return "小米";
        }
    },
    /**
     * 喜马拉雅
     */
    HIMALAYAN {
        @Override
        public String getMediaName() {
            return "himalayan";
        }
        @Override
        public String getDesc() {
            return "喜马拉雅";
        }
    },
    /**
     * VIVO
     */
    VIVO {
        @Override
        public String getMediaName() {
            return "vivo";
        }
        @Override
        public String getDesc() {
            return "vivo";
        }
    },
    /**
     * OPPO
     */
    OPPO {
        @Override
        public String getMediaName() {
            return "oppo";
        }
        @Override
        public String getDesc() {
            return "oppo";
        }
    },
    /**
     * jrtt_shortVedio
     */
    JRTT_SHORTVIDEO_OLD {
        @Override
        public String getMediaName() {
            return "jrtt_shortVideo_old";
        }
        @Override
        public String getDesc() {
            return "jrtt_shortVedio_old";
        }
    },
    /**
     * jrtt_shortVedio
     */
    JRTT_SHORTVIDEO {
        @Override
        public String getMediaName() {
            return "jrtt_shortVideo";
        }
        @Override
        public String getDesc() {
            return "jrtt_shortVedio";
        }
    },
    /**
     * jrtt_shortVedio
     */
    JRTT_WECHATH5 {
        @Override
        public String getMediaName() {
            return "jrtt_wechath5";
        }
        @Override
        public String getDesc() {
            return "jrtt_wechath5";
        }
    },
    /**
     * tiktok_shortVedio
     */
    TIKTOK_SHORTVIDEO {
        @Override
        public String getMediaName() {
            return "tiktok_shortVideo";
        }
        @Override
        public String getDesc() {
            return "tiktok_shortVideo";
        }
    },
    /**
     * gdt_shortVedio
     */
    GDT_SHORTVIDEO {
        @Override
        public String getMediaName() {
            return "gdt_shortVideo";
        }
        @Override
        public String getDesc() {
            return "gdt_shortVedio";
        }
    },
    /**
     * 网易有道
     */
    YOUDAO {
        @Override
        public String getMediaName() {
            return "youdao";
        }
        @Override
        public String getDesc() {
            return "网易有道";
        }
    },
    /**
     * jrtt_freevideo
     */
    JRTT_FREEVIDEO {
        @Override
        public String getMediaName() {
            return "jrtt_freevideo";
        }
        @Override
        public String getDesc() {
            return "jrtt_freevideo";
        }
    };

    /**
     * 媒体名称
     */
    public abstract String getMediaName();
    /**
     * 媒体描述
     */
    public abstract String getDesc();

    /**
     * 根据媒体名称获取媒体枚举
     * @param mediaName 媒体名称
     * @return 媒体枚举
     */
    public static MediaEnum getByMediaName(String mediaName) {
        for (MediaEnum mediaEnum : MediaEnum.values()) {
            if (mediaEnum.getMediaName().equals(mediaName)) {
                return mediaEnum;
            }
        }
        return null;
    }
}
