package com.lwby.aas.enums;


public enum StoreEnum {


    //媒体 媒体编号 媒体名
    //小米 11       xiaomi
    //华为 12       huawei
    //oppo 13       oppo
    //vivo 14       vivo
    //应用宝15      yingyongbao
    //魅族 16       meizu
    //360手助17     360zhushou
    //百度手助18    baiduzhushou
    //其他（阿里等）19other
    //今日头条21    jinritoutiao
    //广点通/微信22guangdiantong
    //快手	23	kuaishou

    xiaomi("11","xiaomi"),
    huawei("12","huawei"),
    oppo("13","oppo"),
    vivo("14","vivo"),
    yingyongbao("15","yingyongbao"),
    meizu("16","meizu"),
    zhushou("17","360zhushou"),
    baiduzhushou("18","baiduzhushou"),
    other("19","other"),
    jinritoutiao("21","jinritoutiao"),
    guangdiantong("22","guangdiantong"),
    kuaishou("23","kuaishou"),
    uc("24","uc"),
    qutoutiao("25","qutoutiao"),
    youdao("28","youdao"),
    dystore("33","dystore")
    ;

    private String storePrefix;

    private String  storeDesc;

    /**
     * 获取
     *
     * @return 对应的
     */
    public String getStorePrefix() {
        return storePrefix;
    }

    /**
     * 设置
     *
     * @param storePrefix 要设置的
     */
    public void setStorePrefix(String storePrefix) {
        this.storePrefix = storePrefix;
    }

    /**
     * 获取
     *
     * @return 对应的
     */
    public String getStoreDesc() {
        return storeDesc;
    }

    /**
     * 设置
     *
     * @param storeDesc 要设置的
     */
    public void setStoreDesc(String storeDesc) {
        this.storeDesc = storeDesc;
    }

    StoreEnum(String storePrefix, String storeDesc) {
        this.storePrefix = storePrefix;
        this.storeDesc = storeDesc;
    }

    /**
     * 根据指定的渠道前缀获取对应的通用状态的枚举对象，未找到则返回null
     *
     * @param channelPre 指定的渠道前缀
     * @return 对应的通用状态的枚举对象，未找到则返回null
     */
    public static String getStoreDescByChannelPre(String channelPre){
            for (StoreEnum storeEnum : StoreEnum.values()) {
                if (storeEnum.getStorePrefix().equals(channelPre)) {
                    return storeEnum.getStoreDesc();
                }
            }
            return null;
    }

    /**
     * 根据指定的渠道前缀获取对应的通用状态的枚举对象
     * @param channelPre 渠道前缀
     * @return 枚举对象，未找到则返回null
     */
    public static StoreEnum getByChannelPre(String channelPre){
        for (StoreEnum storeEnum : StoreEnum.values()) {
            if (storeEnum.getStorePrefix().equals(channelPre)) {
                return storeEnum;
            }
        }
        return null;
    }
}
