package com.lwby.aas.factory;

import com.lwby.aas.enums.MediaEnum;
import com.lwby.aas.handle.AttributionHandle;
import com.lwby.aas.service.IMediaActiveService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.ApplicationContext;
import org.springframework.stereotype.Service;

import javax.annotation.PostConstruct;
import java.util.ArrayList;
import java.util.Comparator;
import java.util.List;
import java.util.stream.Collectors;

/**
 * @author songxinyu
 * @version AttributeHandleFactory.java, v 0.1 2024年02月23日 18:51 songxinyu Exp $
 */
@Service
public class AttributeHandleFactory {

    @Autowired
    ApplicationContext applicationContext;

    List<AttributionHandle> handleList = new ArrayList<>();

    public List<AttributionHandle> getHandleList() {
        return handleList;
    }

    @PostConstruct
    public void init() {
        handleList = applicationContext.getBeansOfType(AttributionHandle.class).values().stream()
                .sorted(Comparator.comparingInt(AttributionHandle::order).reversed())
                .collect(Collectors.toList());
    }
}
