package com.lwby.aas.factory;

import com.google.common.collect.ArrayListMultimap;
import com.lwby.aas.enums.MediaEnum;
import com.lwby.aas.service.IMediaActiveService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.ApplicationContext;
import org.springframework.stereotype.Service;

import javax.annotation.PostConstruct;
import java.util.List;
import java.util.Map;

@Service
public class MediaActiveFactory {

    @Autowired
    ApplicationContext applicationContext;


    ArrayListMultimap<MediaEnum, IMediaActiveService> multimap = ArrayListMultimap.create();

    /**
     * @return
     */
    /**
     *
     * @return
     */
    public IMediaActiveService getMediaActiveService(MediaEnum mediaEnum) {
        List<IMediaActiveService> mediaActiveServices = multimap.get(mediaEnum);
        return mediaActiveServices.get(0);
    }



    /**
     *
     */
    @PostConstruct
    public void init() {
        Map<String, IMediaActiveService> type = applicationContext.getBeansOfType(IMediaActiveService.class);
        for (Map.Entry<String, IMediaActiveService> item : type.entrySet()) {
            multimap.put(item.getValue().getMediaEnum(), item.getValue());
        }
    }


}
