package com.lwby.aas.handle.impl;

import com.lwby.aas.handle.AttributionHandle;
import com.lwby.aas.handle.BaseHelper;
import com.lwby.aas.handle.Flow;
import com.lwby.aas.vo.Action;
import com.lwby.aas.vo.ClientInfo;
import com.lwby.aas.vo.DeliveryDeviceInfo;
import org.apache.commons.lang3.StringUtils;
import org.springframework.stereotype.Component;

import java.util.Objects;

@Component
public class BeforeHandle extends BaseHelper implements AttributionHandle {
    @Override
    public int order() {
        return 8;
    }

    @Override
    public Flow handle(Action action) {
        DeliveryDeviceInfo dd = action.getDeliveryDeviceInfo();
        ClientInfo ci = action.getClientInfo();

        action.setPlatformId(ci.getPlatformId());
        action.setUserId(ci.getUser().getId());
        action.setDeviceId(ci.getDID());
        action.setNewUser(isCurrentDayTime(ci.getUser().getRegistrationDate()));
        action.setRegistrationDate(ci.getUser().getRegistrationDate());
        //商店的不赋值
        if (Objects.nonNull(dd)) {
            action.setChannelId(StringUtils.isNotBlank(dd.getDj_channel()) ? Integer.parseInt(dd.getDj_channel()) : -1);
            action.setPlanId(StringUtils.isNotBlank(dd.getAd_plan_id()) ? Integer.parseInt(dd.getAd_plan_id()) : -1);
            action.setAdvertiserId(dd.getAdvertiser_id());
            action.setMedia(dd.getMedia());
        }
        return Flow.NEXT;
    }
}
