package com.lwby.aas.handle.impl;

import com.alicp.jetcache.anno.CacheRefresh;
import com.alicp.jetcache.anno.CacheType;
import com.alicp.jetcache.anno.Cached;
import com.lwby.aas.handle.AttributionType;
import com.lwby.aas.handle.Flow;
import com.lwby.aas.vo.Action;
import com.lwby.aas.vo.ClientInfo;
import com.lwby.aas.vo.DeliveryDeviceInfo;
import org.springframework.stereotype.Component;

import java.util.*;
import java.util.stream.Collectors;

@Component
public class PlanAttributionHandle extends ChannelAttributionHandle{

    @Override
    public int order() {
        return 2;
    }

    @Override
    public Flow handle(Action action) {
        //如果投放帐号没有配置计划归因，继续执行下一个渠道归因处理器
        if(!getPlanAccount().contains(action.getAdvertiserId())){
            return Flow.NEXT;
        }

        return this.handle0(action, AttributionType.PLAN);
    }

    @Cached(name="plan_account", cacheType = CacheType.LOCAL)
    @CacheRefresh(refresh = 300)
    public Set<String> getPlanAccount(){
        List<String> ls = lwbyJdbcTemplate.queryForList("select account from account_plan_callback",String.class);

        return ls.stream()
                 .flatMap(e -> Arrays.stream(e.split(",")))
                 .map(String::trim)
                 .filter(_s -> _s.matches("\\d+"))
                 .collect(Collectors.toSet());
    }
}